<?php
/*  Copyright 2008  Andrea Belvedere  (email : scieck at gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
require_once GANBATTE_DIR . '/view/ganbatte_view.php';

class GanbatteController
{
	var $_kana;
	var $_view;


	function GanbatteController(&$kana)
	{
		$this->_kana = $kana;
		$this->_view =& new GanbatteView();

		add_action('wp_print_scripts', array(&$this, 'ganbatte_print_scripts'));
		add_action('wp_head', array(&$this, 'ganbatte_head'));
		add_action('init', array(&$this, 'ganbatte_init'));
		add_filter('the_content', array(&$this, 'ganbatte_the_content'),9);
	}

	function ganbatte_init()
	{
		if (isset($_POST['ganbatte_ajax']) && strcasecmp($_POST['ganbatte_ajax'], 'yes') == 0) {
			$this->process_request();
			exit();
		}
	}

	function process_request()
	{
		$ganbatte_action = isset($_POST['ganbatte_action']) ? $_POST['ganbatte_action'] : null;
		if ($ganbatte_action == 'kana-start') {
			$kanas = $this->_kana->get_all_kana();
			@header('Content-Type: application/x-json; charset=utf-8');
			echo $this->ganbatte_kanas_encode($kanas);
		}
	}

	function ganbatte_the_content($content)
	{
		$regex = '/\[\s*ganbatte-kana\s*\]/';
		return preg_replace_callback($regex, array(&$this, 'ganbatte_the_content_callback'), $content, 1);
	}

	function ganbatte_the_content_callback($matches)
	{
		$kanas = $this->_kana->get_all_kana();
		return $this->_view->start_view($kanas);		
	}

	function ganbatte_head()
	{
		echo '<link rel="stylesheet" type="text/css" href="'. GANBATTE_URL . '/css/ganbatte.css" />';
	}

	function ganbatte_print_scripts() 
	{
		wp_register_script('ganbatte_js', GANBATTE_URL . '/js/ganbatte.js', array('prototype'));
		wp_enqueue_script('ganbatte_js');
	}

	/**
	 * @param $kanas array An array of kanas to json encode
	 */
	function ganbatte_kanas_encode($kanas)
	{
		$enc = '{"kanas": [';
		foreach ($kanas as $kana) {
			$enc .= '{"id":"'.$kana['id'].'","kana_row":"'.
				$kana['kana_row'].'","romaji":"'.$kana['romaji'].'","hiragana":"'.
				$kana['hiragana'].'","katakana":"'.$kana['katakana'].'"},';
		}
		$enc = substr($enc, 0, -1);
		$enc .= ']}';

		return $enc;
	}
}
