<?php
/*  Copyright YEAR  PLUGIN_AUTHOR_NAME  (email : PLUGIN AUTHOR EMAIL)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
class Kana
{
	var $_kanas;
	var $_table;

	function Kana()
	{
		global $wpdb;
		$this->_table = $wpdb->prefix.'kana';
		$this->_kanas = array();
	}

	function get_all_kana()
	{
		if (!empty($this->_kanas)) return $this->_kanas;
		
		global $wpdb;
		$query = "SELECT * FROM {$this->_table} ORDER BY id ASC";
		$res = $wpdb->get_results($query);

		if (is_array($res) && count($res) > 0) {
			foreach ($res as $kana) {
				$this->_kanas[] = array('id' => $kana->id,
										'kana_row' => $kana->kana_row,
										'romaji' => $kana->romaji,
										'hiragana' => $kana->hiragana,
										'katakana' => $kana->katakana);
			}
		}
		return $this->_kanas;
	}
	
	function create()
	{
		global $wpdb;
		if($wpdb->get_var("SHOW TABLES LIKE '{$this->_table}'") == $this->_table) return;

		$query = "CREATE TABLE " . $this->_table . " (
                  id SERIAL,
                  kana_row VARCHAR(4) NOT NULL,
                  romaji VARCHAR(4) NOT NULL,
	              hiragana VARCHAR(4) NOT NULL,
	              katakana VARCHAR(4) NOT NULL
	            ) charset=utf8;";

		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		dbDelta($query);

		// insert kanas
		$queries = $this->_kana_inserts();
		foreach ($queries as $query) {
			$wpdb->query($query);
		}
	}

	function delete()
	{
		global $wpdb;
		if($wpdb->get_var("SHOW TABLES LIKE '{$this->_table}'") != $this->_table) return;

		$query = "DROP TABLE {$this->_table}";
		$wpdb->query($query);
	}

	function _kana_inserts()
	{
		$queries = array();
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('a','a','あ','ア');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('a','i','い','イ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('a','u','う','ウ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('a','e','え','エ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('a','o','お','オ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('ka','ka','か','カ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('ka','ki','き','キ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('ka','ku','く','ク');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('ka','ke','け','ケ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('ka','ko','こ','コ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('sa','sa','さ','サ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('sa','shi','し','シ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('sa','su','す','ス');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('sa','se','せ','セ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('sa','so','そ','ソ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('ta','ta','た','タ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('ta','chi','ち','チ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('ta','tsu','つ','ツ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('ta','te','て','テ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('ta','to','と','ト');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('na','na','な','ナ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('na','ni','に','ニ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('na','nu','ぬ','ヌ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('na','ne','ね','ネ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('na','no','の','ノ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('ha','ha','は','ハ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('ha','hi','ひ','ヒ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('ha','fu','ふ','フ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('ha','he','へ','ヘ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('ha','ho','ほ','ホ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('ma','ma','ま','マ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('ma','mi','み','ミ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('ma','mu','む','ム');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('ma','me','め','メ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('ma','mo','も','モ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('ya','ya','や','ヤ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('ya','yu','ゆ','ユ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('ya','yo','よ','ヨ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('ra','ra','ら','ラ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('ra','ri','り','リ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('ra','ru','る','ル');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('ra','re','れ','レ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('ra','ro','ろ','ロ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('wa','wa','わ','ワ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('wa','wo','を','ヲ');";
		$queries[] = "INSERT INTO {$this->_table} (kana_row,romaji,hiragana,katakana) VALUES ('n','n','ん','ン');";
		return $queries;
	}
}