<?php
/*  Copyright 2008  Andrea Belvedere  (email : scieck at gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
/**
 * This class doesn't do any logic
 * only displays data
 */
class GanbatteView
{
	function GanbatteView() {}

	/**
	 * Create the table to display the kana chart
	 * @param $kanas array Contains the kana table
	 * @return String An html table
	 */
	function kana_table($kanas)
	{
		if (!is_array($kanas)) return;
		
		$i = 0;
		$html = '<table border="1" cellpadding="0" cellspacing="0" id="ganbatte-kana-chart"><tr>'."\n";
		foreach ($kanas as $kana) {
			if (($i != 0) && ($i % 5) == 0) {
				$i = 0;
				$html .= "\n</tr>\n<tr>\n";
			}
			
			$html .= '<td><span class="hiragana">'.
				$kana['hiragana'].'</span>&nbsp;<span class="katakana">'.
				$kana['katakana'].'</span><br /><span class="romaji">'.
				$kana['romaji'].'</span></td>'."\n";

			switch ($kana['kana_row']) {
			case 'ya':
				{
					if ($kana['romaji'] != 'yo') {
						$html .= '<td>&nbsp;</td>';
						$i++;
					}
				}
				break;
			case 'wa':
				{
					if ($kana['romaji'] != 'wo') {
						for($k = 0; $k < 3; $k++ ) {
							$html .= '<td>&nbsp;</td>';
							$i++;
						}
					}
				}
				break;
			case 'n':
				{
					for ($k = 0; $k < 4; $k++) {
						$html .= '<td>&nbsp;</td>';
					}
				}
				break;
			}
			$i++;
		}
		$html .= '</tr></table>';

		return $html;
	}

	/**
	 * @param $kanas array An associative array of kanas
	 */
	function start_view($kanas)
	{
		$html = '<table border="0" cellpadding="0" cellspacing="0" id="ganbatte-console">'.
			'<tr><td>'.$this->kana_table($kanas).'</td>'.
			'<td>'.$this->game_start_form().'</td></tr></table>';

		return $this->ganbatte_wrap($html);
	}

	function game_start_form()
	{
		$url = parse_url($_SERVER['REQUEST_URI']);
		$url = $url['path'] . (empty($url['query']) ? '' : '?' . $url['query']);

		$html = '<div id="ganbatte-kana-control"><form method="post" action="'.$url.'" name="ganbatte-kana-control" id="ganbatte-kana-start-form">'.
			'<input type="hidden" name="ganbatte_ajax" value="no" id="ganbatte_ajax" />'.
			'<input type="hidden" name="ganbatte_action" value="kana-start" />'.
			'<table border="0" cellpadding="0" cellspacing="0">'.
			'<tr><td><label>'.__('view', GANBATTE_LOCALIZE).'</label></td><td><select name="kana-view">'.
			'<option value="kana">kana</option>'.
			'<option value="romaji">romaji</option>'.
			'</select></td></tr>'.
			'<tr><td><label>'.__('learn', GANBATTE_LOCALIZE).'</label></td>'.
			'<td><select name="kana-learn">'.
			'<option value="hiragana">hiragana</option>'.
			'<option value="katakana">katakana</option>'.
			'</select></td></tr>'.
			'<tr><td colspan="2" style="text-align:right;">'.
			'<input type="submit" name="submit" value="'.__('Start', GANBATTE_LOCALIZE).'" id="ganbatte-kana-start" />'.
			'</td></tr></table></form></div>';

		return $html;
	}

	function ganbatte_wrap($html)
	{
		return '<div id="ganbatte-kana">'.$html.'</div>';
	}
}